
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Orbix_quiz_assistant_sessionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const orbix_quiz_assistant_sessions = await db.orbix_quiz_assistant_sessions.create(
            {
                id: data.id || undefined,
        
        topic: data.topic
        ||
        null
            ,
            
        target_question_count: data.target_question_count
        ||
        null
            ,
            
        age_group: data.age_group
        ||
        null
            ,
            
        difficulty: data.difficulty
        ||
        null
            ,
            
        include_images: data.include_images
        ||
        false
        
            ,
            
        status: data.status
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
        started_at: data.started_at
        ||
        null
            ,
            
        finished_at: data.finished_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await orbix_quiz_assistant_sessions.setUser( data.user || null, {
            transaction,
        });
        
        await orbix_quiz_assistant_sessions.setGenerated_quiz( data.generated_quiz || null, {
            transaction,
        });
        

        

        

        return orbix_quiz_assistant_sessions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const orbix_quiz_assistant_sessionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                topic: item.topic
            ||
            null
            ,
            
                target_question_count: item.target_question_count
            ||
            null
            ,
            
                age_group: item.age_group
            ||
            null
            ,
            
                difficulty: item.difficulty
            ||
            null
            ,
            
                include_images: item.include_images
            ||
            false
        
            ,
            
                status: item.status
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
                started_at: item.started_at
            ||
            null
            ,
            
                finished_at: item.finished_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const orbix_quiz_assistant_sessions = await db.orbix_quiz_assistant_sessions.bulkCreate(orbix_quiz_assistant_sessionsData, { transaction });

        // For each item created, replace relation files
        

        return orbix_quiz_assistant_sessions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const orbix_quiz_assistant_sessions = await db.orbix_quiz_assistant_sessions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.topic !== undefined) updatePayload.topic = data.topic;
        
        
        if (data.target_question_count !== undefined) updatePayload.target_question_count = data.target_question_count;
        
        
        if (data.age_group !== undefined) updatePayload.age_group = data.age_group;
        
        
        if (data.difficulty !== undefined) updatePayload.difficulty = data.difficulty;
        
        
        if (data.include_images !== undefined) updatePayload.include_images = data.include_images;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        if (data.started_at !== undefined) updatePayload.started_at = data.started_at;
        
        
        if (data.finished_at !== undefined) updatePayload.finished_at = data.finished_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await orbix_quiz_assistant_sessions.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await orbix_quiz_assistant_sessions.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.generated_quiz !== undefined) {
            await orbix_quiz_assistant_sessions.setGenerated_quiz(
              
              data.generated_quiz,
              
              { transaction }
            );
        }
        

        
        

        

        return orbix_quiz_assistant_sessions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const orbix_quiz_assistant_sessions = await db.orbix_quiz_assistant_sessions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of orbix_quiz_assistant_sessions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of orbix_quiz_assistant_sessions) {
                await record.destroy({transaction});
            }
        });


        return orbix_quiz_assistant_sessions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const orbix_quiz_assistant_sessions = await db.orbix_quiz_assistant_sessions.findByPk(id, options);

        await orbix_quiz_assistant_sessions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await orbix_quiz_assistant_sessions.destroy({
            transaction
        });

        return orbix_quiz_assistant_sessions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const orbix_quiz_assistant_sessions = await db.orbix_quiz_assistant_sessions.findOne(
            { where },
            { transaction },
        );

        if (!orbix_quiz_assistant_sessions) {
            return orbix_quiz_assistant_sessions;
        }

        const output = orbix_quiz_assistant_sessions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await orbix_quiz_assistant_sessions.getUser({
            transaction
        });
        
        
        output.generated_quiz = await orbix_quiz_assistant_sessions.getGenerated_quiz({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.quizzes,
        as: 'generated_quiz',
        
        where: filter.generated_quiz ? {
          [Op.or]: [
            { id: { [Op.in]: filter.generated_quiz.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.generated_quiz.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.topic) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'orbix_quiz_assistant_sessions',
                        'topic',
                        filter.topic,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'orbix_quiz_assistant_sessions',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            started_at: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    finished_at: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.target_question_countRange) {
                const [start, end] = filter.target_question_countRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    target_question_count: {
                    ...where.target_question_count,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    target_question_count: {
                    ...where.target_question_count,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.started_atRange) {
                const [start, end] = filter.started_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    started_at: {
                    ...where.started_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    started_at: {
                    ...where.started_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.finished_atRange) {
                const [start, end] = filter.finished_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    finished_at: {
                    ...where.finished_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    finished_at: {
                    ...where.finished_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.age_group) {
                where = {
                    ...where,
                age_group: filter.age_group,
            };
            }
            
            if (filter.difficulty) {
                where = {
                    ...where,
                difficulty: filter.difficulty,
            };
            }
            
            if (filter.include_images) {
                where = {
                    ...where,
                include_images: filter.include_images,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.orbix_quiz_assistant_sessions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'orbix_quiz_assistant_sessions',
                        'topic',
                        query,
                    ),
                ],
            };
        }

        const records = await db.orbix_quiz_assistant_sessions.findAll({
            attributes: [ 'id', 'topic' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['topic', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.topic,
        }));
    }

    
};

